// Demonstrate problem with Fl_Text_Display: unable to scroll
// to bottom with wrap_mode(WRAP_AT_BOUNDS) + style table with
// font size that's != textsize(). -- erco Oct 7 2017

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Text_Display.H>
int main() {
    // Style table
    Fl_Text_Display::Style_Table_Entry stable[] = {
        // FONT COLOR      FONT FACE   FONT SIZE
        // --------------- ----------- --------------
        {  FL_BLACK,       FL_COURIER, 18 }, // A - Red
        {  FL_BLUE,        FL_COURIER, 18 }, // B - Blue
    };
    Fl_Window *win = new Fl_Window(640, 480);
    Fl_Text_Display *disp = new Fl_Text_Display(20, 20, 640-40, 480-40, "Display");
    Fl_Text_Buffer *tbuff = new Fl_Text_Buffer();      // text buffer
    Fl_Text_Buffer *sbuff = new Fl_Text_Buffer();      // style buffer
    disp->buffer(tbuff);
    int stable_size = sizeof(stable)/sizeof(stable[0]);
    disp->highlight_data(sbuff, stable, stable_size, 'A', 0, 0);
    disp->wrap_mode(Fl_Text_Display::WRAP_AT_BOUNDS, 0);
    //disp->textsize(18);	// UNCOMMENT TO FIX
    char s[256];
    for ( int t=0; t<200; t++ ) {
        sprintf(s, "This is a looooooooooooooooooooooooooooooooong line of text %04d\n", t);
	tbuff->append(s);
        int len = strlen(s);
	memset(s, 'A', len);
	sbuff->append(s);
    }
    win->resizable(*disp);
    win->show();
    return(Fl::run());
}

